window.Gleam.initSearch([{"doc":"glenv","title":"glenv","content":"# glenv\n\n[![Package Version](https://img.shields.io/hexpm/v/glenv)](https://hex.pm/packages/glenv)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glenv/)\n\n```sh\ngleam add glenv\n```\n```gleam\nimport glenv\n\npub type Env {\n  Env(hello: String, foo: Float, count: Int, is_on: Bool)\n}\n\npub fn main() {\n  let definitions = [\n    #(&quot;HELLO&quot;, glenv.String),\n    #(&quot;FOO&quot;, glenv.Float),\n    #(&quot;COUNT&quot;, glenv.Int),\n    #(&quot;IS_ON&quot;, glenv.Bool),\n  ]\n  let decoder =\n    decode.into({\n      use hello &lt;- decode.parameter\n      use foo &lt;- decode.parameter\n      use count &lt;- decode.parameter\n      use is_on &lt;- decode.parameter\n\n      Env(hello: hello, foo: foo, count: count, is_on: is_on)\n    })\n    |&gt; decode.field(&quot;HELLO&quot;, decode.string)\n    |&gt; decode.field(&quot;FOO&quot;, decode.float)\n    |&gt; decode.field(&quot;COUNT&quot;, decode.int)\n    |&gt; decode.field(&quot;IS_ON&quot;, decode.bool)\n\n  let assert Ok(env) = glenv.load(decoder, definitions)\n\n  env.hello == &quot;hello&quot;\n  env.foo == 1.0\n  env.count == 1\n  env.is_on == True\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/glenv&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"glenv","title":"Definition","content":"pub type Definition =\n  #(String, Type)\n Definition represents a single environment variable, from key to type.\n\nSynonyms:\nglenv.Definition\nglenv Definition","url":"glenv.html#Definition"},{"doc":"glenv","title":"Type","content":"pub type Type {\n  Bool\n  Float\n  Int\n  String\n}\n Type represents the type of an environment variable.\n This dictates how the environment variable is parsed.\nBool\n\n\nFloat\n\n\nInt\n\n\nString\n\n\nSynonyms:\nglenv.Type\nglenv Type","url":"glenv.html#Type"},{"doc":"glenv","title":"load","content":"pub fn load(\n  decoder: Decoder(a),\n  definitions: List(#(String, Type)),\n) -&gt; Result(a, Nil)\n Load parses the environment variables and returns a Result containing the environment.\n Takes a decoder from the gleam/decode library and a list of definitions.\n \n ## Examples\n\n \n type Env {\n   Env(hello: String, foo: Float, count: Int, is_on: Bool)\n }\n\n let definitions = [\n   #(&quot;HELLO&quot;, glenv.String),\n   #(&quot;FOO&quot;, glenv.Float),\n   #(&quot;COUNT&quot;, glenv.Int),\n   #(&quot;IS_ON&quot;, glenv.Bool),\n ]\n let decoder =\n   decode.into({\n     use hello &lt;- decode.parameter\n     use foo &lt;- decode.parameter\n     use count &lt;- decode.parameter\n     use is_on &lt;- decode.parameter\n\n     Env(hello: hello, foo: foo, count: count, is_on: is_on)\n   })\n   |&gt; decode.field(&quot;HELLO&quot;, decode.string)\n   |&gt; decode.field(&quot;FOO&quot;, decode.float)\n   |&gt; decode.field(&quot;COUNT&quot;, decode.int)\n   |&gt; decode.field(&quot;IS_ON&quot;, decode.bool)\n\n let assert Ok(env) = glenv.load(decoder, definitions)\n env.hello // &quot;world&quot;\n env.foo // 1.0\n env.count // 1\n env.is_on // True\n \nSynonyms:\nglenv.load\nglenv load","url":"glenv.html#load"},{"doc":"glenv","title":"parse","content":"pub fn parse(\n  definitions: List(#(String, Type)),\n) -&gt; Result(List(#(String, Dynamic)), Nil)\n\nSynonyms:\nglenv.parse\nglenv parse","url":"glenv.html#parse"},{"doc":"glenv","title":"glenv","content":" glenv is a library for type-sfe environment variable access.\n It is inspried by a Typescript pattern using zod validators\n to parse and validate environment variables.","url":"glenv.html"}]);